## papi 6.0.0~dfsg

=== doc/Makefile ===
.PHONY:	clean clobber distclean install force_me all

all: man
	@echo "Built PAPI user documentation"

html: force_me
	doxygen Doxyfile-html

man: man/man1 man/man3

man/man3: ../src/papi.h ../src/papi.c ../src/high-level/papi_hl.c ../src/papi_fwrappers.c
	doxygen Doxyfile-man3

man/man1: ../src/utils/papi_avail.c ../src/utils/papi_clockres.c  ../src/utils/papi_command_line.c ../src/utils/papi_component_avail.c ../src/utils/papi_cost.c ../src/utils/papi_decode.c ../src/utils/papi_error_codes.c ../src/utils/papi_event_chooser.c ../src/utils/papi_xml_event_info.c ../src/utils/papi_mem_info.c ../src/utils/papi_multiplex_cost.c ../src/utils/papi_native_avail.c  ../src/utils/papi_version.c
	doxygen Doxyfile-man1
 
clean:
	rm -rf man html doxyerror

distclean clobber: clean

install: man
	-rm -f man/man3/HighLevelInfo.3
	-rm -f man/man3/papi_data_structures.3
	-rm -r ../man/man1/*.1 ../man/man3/*.3
	-cp -R man/man1/*.1 ../man/man1
	-cp -R man/man3/*.3 ../man/man3

=== src/ctests/Makefile ===
# File: ctests/Makefile

include Makefile.target

INCLUDE = -I../testlib -I../validation_tests -I.. -I.

testlibdir= ../testlib
TESTLIB= $(testlibdir)/libtestlib.a
DOLOOPS= $(testlibdir)/do_loops.o
CLOCKCORE= $(testlibdir)/clockcore.o

validationlibdir= ../validation_tests
TESTFLOPS= $(validationlibdir)/flops_testcode.o
TESTINS= $(validationlibdir)/instructions_testcode.o
TESTCYCLES = $(validationlibdir)/busy_work.o
DISPLAYERROR= $(validationlibdir)/display_error.o

include Makefile.recipies

.PHONY : install

install: default
	@echo "C tests (DATADIR) being installed in: \"$(DATADIR)\""; 
	-mkdir -p $(DATADIR)/ctests
	-chmod go+rx $(DATADIR)
	-chmod go+rx $(DATADIR)/ctests
	-find . -perm -100 -type f -exec cp {} $(DATADIR)/ctests \;
	-chmod go+rx $(DATADIR)/ctests/*
	-find . -name "*.[ch]" -type f -exec cp {} $(DATADIR)/ctests \;
	-cp Makefile.target $(DATADIR)/ctests/Makefile
	-cat Makefile.recipies >> $(DATADIR)/ctests/Makefile

=== src/components/nvml/tests/Makefile ===
NAME=nvml
include ../../Makefile_comp_tests
# -fverbose-asm -Wa,-adhln=benchSANVML.s

PAPI_NVML_ROOT ?= $(PAPI_CUDA_ROOT)
PAPI_NVML_INC ?= $(PAPI_CUDA_ROOT)/include
PAPI_NVML_LIB ?= $(PAPI_CUDA_ROOT)/lib64/stubs

NVCC = $(PAPI_CUDA_ROOT)/bin/nvcc
NVCFLAGS = -L$(PAPI_NVML_INC) -ccbin=$(CC)
CUDALIBS = -L$(PAPI_NVML_LIB) -L$(PAPI_CUDA_ROOT)/lib64 -lcuda -lcudart -lnvidia-ml -lstdc++
PAPILIB := ../../../libpapi.a  -ldl

%.o:%.cu
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -c -o $@ $<

TESTS = HelloWorld nvml_power_limiting_test

nvml_tests: $(TESTS) 

HelloWorld: HelloWorld.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) 

nvml_power_limiting_test: nvml_power_limiting_test.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o nvml_power_limiting_test nvml_power_limiting_test.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)
	cp nvml_power_limiting_test ~/nvml_power_limiting_test

nvml_power_limit_read_test: nvml_power_limit_read_test.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o nvml_power_limit_read_test nvml_power_limit_read_test.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)
	cp nvml_power_limit_read_test ~/nvml_power_limit_read_test

benchSANVML: benchSANVML.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o benchSANVML benchSANVML.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) 

clean:
	rm -f $(TESTS) *.o
	rm -f benchSANVML
	rm -f nvmlcap_plot results*

FORCE:

=== src/components/rapl/tests/Makefile ===
NAME=rapl
include ../../Makefile_comp_tests.target

TESTS = rapl_basic rapl_busy rapl_wraparound rapl_overflow

DOLOOPS= $(testlibdir)/do_loops.o

rapl_tests: $(TESTS)

rapl_overflow.o:	rapl_overflow.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c rapl_overflow.c

rapl_overflow:	rapl_overflow.o $(DOLOOPS) $(UTILOBJS) $(PAPILIB)
	$(CC) $(INCLUDE) -o rapl_overflow rapl_overflow.o $(DOLOOPS) $(UTILOBJS) $(PAPILIB) $(LDFLAGS)


rapl_basic.o:	rapl_basic.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c rapl_basic.c -o rapl_basic.o -DBASIC_TEST=1

rapl_basic: rapl_basic.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(INCLUDE) -o rapl_basic rapl_basic.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) 


rapl_busy.o:	rapl_basic.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c rapl_basic.c -o rapl_busy.o -DBUSY_TEST=1

rapl_busy: rapl_busy.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(INCLUDE) -o rapl_busy rapl_busy.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) 


rapl_wraparound.o:	rapl_basic.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c rapl_basic.c -o rapl_wraparound.o -DWRAP_TEST=1

rapl_wraparound: rapl_wraparound.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(INCLUDE) -o rapl_wraparound rapl_wraparound.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) 


clean:
	rm -f $(TESTS) *.o *~

=== src/components/rocm_smi/tests/Makefile ===
NAME=rocm_smi
include ../../Makefile_comp_tests.target

TESTS = 

rocm_smi_tests: $(TESTS)

# We have no standardized tests yet. the below are examples of what one might look like;
# but the "-fverbose-asm -Wa,-adhln=testPCP.s" are not usually included; those are for 
# advanced debugging. So is "-Xlinker -Map=testPCP_link.map"; those can be left off.
#testPCP.o:	testPCP.c
#	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c testPCP.c -o testPCP.o -fverbose-asm -Wa,-adhln=testPCP.s

#testPCP: testPCP.o $(UTILOBJS) $(PAPILIB)
#	$(CC) $(INCLUDE) -o testPCP testPCP.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) -Xlinker -Map=testPCP_link.map

clean:
	rm -f $(TESTS) *.o *~

=== src/components/sde/tests/Makefile ===
NAME=sde
include ../../Makefile_comp_tests.target
INCLUDE += -I../interface -I..
ifeq ($(notdir $(F77)),gfortran)
	FFLAGS +=-ffree-form -ffree-line-length-none
else
	FFLAGS +=-free
endif
FFLAGS +=-g
#CFLAGS +=-g

LDFLAGS +=-L..
SDE_F08_API=$(datadir)/sde_F.o

EXTRA_SRC=../interface/papi_sde_interface.c

TESTS = Minimal_Test Simple_Test Simple2_Test Recorder_Test sde_test_f08

sde_tests: $(TESTS)

weak_symbols.o: $(EXTRA_SRC)
	$(CC) -Wall -c $< -o $@

################################################################################
## Minimal test
prfx=Minimal

Minimal_Test: $(prfx)/Minimal_Test.c
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(PAPILIB) $(LDFLAGS)

################################################################################
## Simple test
prfx=Simple

$(prfx)/libSimple.so: $(prfx)/Simple_Lib.c weak_symbols.o
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o $@ $^

Simple_Test: $(prfx)/Simple_Driver.c $(prfx)/libSimple.so
	$(CC) $^ -o $@ $(INCLUDE) $(CFLAGS) $(PAPILIB) $(LDFLAGS) -lm

################################################################################
## Simple2 test
prfx=Simple2

$(prfx)/libSimple2.so: $(prfx)/Simple2_Lib.c weak_symbols.o
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o $@ $^

Simple2_Test: $(prfx)/Simple2_Driver.c $(prfx)/libSimple2.so
	$(CC) $^ -o $@ $(INCLUDE) $(CFLAGS) $(PAPILIB) $(LDFLAGS) -lm

################################################################################
## Recorder test
prfx=Recorder

$(prfx)/libRecorder.so: $(prfx)/Lib_With_Recorder.c weak_symbols.o
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o $@ $^

Recorder_Test: $(prfx)/Recorder_Driver.c $(prfx)/libRecorder.so
	$(CC) $^ -o $@ $(INCLUDE) $(CFLAGS) $(PAPILIB) $(LDFLAGS) -lm

################################################################################
## Advanced test
prfx=Advanced_C+FORTRAN
rcrd_prfx=Recorder

sde_test_f08: $(prfx)/sde_test_f08.F90 $(UTILOBJS) $(PAPILIB) $(prfx)/libXandria.so $(prfx)/libGamum.so $(rcrd_prfx)/libRecorder.so
	$(F77) $< -o $@ $(INCLUDE) $(FFLAGS) $(prfx)/libXandria.so $(prfx)/libGamum.so $(rcrd_prfx)/libRecorder.so $(PAPILIB) $(LDFLAGS)

$(prfx)/libXandria.so: $(prfx)/Xandria.F90 weak_symbols.o
	$(F77) -shared -Wall -fPIC $(FFLAGS) $(INCLUDE) -o $@ $^ $(SDE_F08_API)

$(prfx)/libGamum.so: $(prfx)/Gamum.c weak_symbols.o
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o $@ $^


LIBS=Advanced_C+FORTRAN/libXandria.so Advanced_C+FORTRAN/libGamum.so Recorder/libRecorder.so Simple/libSimple.so Simple2/libSimple2.so

clean:
	rm -f *.o *.mod $(LIBS)

mrproper: clean
	rm -f $(TESTS)

=== debian/changelog ===
papi (6.0.0~dfsg-2) unstable; urgency=medium

  * Rewrite shebang to python3.
  * Move PAPI_derived_event_files manpage to section 5.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 04 Apr 2020 22:16:18 +0200

papi (6.0.0~dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Bump libpfm4-dev B-D to >= 4.10.1+git41.
  * Bump SONAME to libpapi.so.6.0.
  * Update symbols for 6.0.0.
  * Refresh patches.
  * fix-typos.patch: Fix some more typos found by Lintian.
  * Build with dh-python for the new papi_hl_output_writer.py script.
  * Bump Standards-Version to 4.5.0. No changes needed.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Mar 2020 18:59:29 +0100

=== debian/control ===
Source: papi
Section: devel
Priority: optional
Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
Uploaders:
 Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-sequence-python3,
 libpfm4-dev (>= 4.10.1+git41),
 gfortran,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://icl.utk.edu/papi/software/index.html
Vcs-Browser: https://salsa.debian.org/hpc-team/papi
Vcs-Git: https://salsa.debian.org/hpc-team/papi.git

Package: libpapi6.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: PAPI runtime (shared libraries)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 Accessing performance counters from userspace may require reducing the paranoia
 level in /proc/sys/kernel/perf_event_paranoid, see README.Debian for details.
 .
 This package provides the shared library.

Package: libpapi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libpapi${papi:SOVERSION} (= ${binary:Version}),
 ${misc:Depends}
Description: PAPI development files (headers and API documentation)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides the development files of PAPI.

Package: papi-tools
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${python3:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Description: PAPI utilities
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides utilities provided by the PAPI software.

Package: papi-examples
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libpapi-dev (>= ${source:Version}),
 libpapi-dev (<< ${source:Upstream-Version}.~-~),
 ${misc:Depends}
Recommends:
 build-essential,
 gfortran,
 mpi-default-dev,
Description: PAPI example files and test programs
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides examples and tests of the PAPI software.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

SOVERSION	 = 6.0

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS	 = yes
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

# Upstream does not use CPPFLAGS
CFLAGS	+= $(CPPFLAGS)

%:
	dh $@ --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=src -- \
		--with-static-lib=yes \
		--with-shared-lib=yes \
		--with-shlib-tools \
		--with-perf-events \
		--with-pfm-incdir=/usr/include \
		--with-pfm-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		CC=$(CC)
	# for reproducibility
	sed -r -i '/^[CF]FLAGS/s/-fdebug-prefix-map=\S*\s*//' \
		src/ctests/Makefile.target \
		src/ftests/Makefile.target \
		src/testlib/Makefile.target \
		src/validation_tests/Makefile.target \
		src/components/Makefile_comp_tests.target

override_dh_auto_test:
	-env LD_LIBRARY_PATH=$(CURDIR)/src:$(LD_LIBRARY_PATH) dh_auto_test

override_dh_auto_install:
	mkdir -p debian/tmp/usr/bin
	dh_auto_install --sourcedirectory=src -- install-all
	mv debian/tmp/usr/bin/papi_hl_output_writer.py debian/tmp/usr/bin/papi_hl_output_writer
	# delete example binaries
	find debian/tmp/usr/share/papi -perm -100 -type f -delete
	find debian/tmp/usr/share/papi -name \*.a -type f -delete
	find debian/tmp/usr/share/papi -name Makefile -type f -print0 | \
		xargs -0r sed -i -e 's@ [^ ]*-f\(file\|debug\)-prefix-map=[^ ]*@@g'

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

override_dh_makeshlibs:
	dh_makeshlibs -a -- -c4

override_dh_shlibdeps:
	dh_shlibdeps -a -- --warnings=7

override_dh_missing:
	dh_missing --list-missing

override_dh_installchangelogs:
	dh_installchangelogs RELEASENOTES.txt

override_dh_compress:
	dh_compress -X.c -X.h -X.F -XMakefile

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'papi:SOVERSION=$(SOVERSION)'


TEMPLATES	:= $(wildcard debian/libpapiSOVERSION.*)
GENERATED	 = $(subst SOVERSION,$(SOVERSION),$(TEMPLATES))

libpapi$(SOVERSION).%: libpapiSOVERSION.%
	sed 's/@SOVERSION@/$(SOVERSION)/g' $< > $@

build-generated: $(GENERATED) ;
clean-generated:
	$(RM) $(GENERATED)

override_dh_auto_configure: build-generated
clean: clean-generated

=== debian/watch ===
version=4

opts="dversionmangle=s/\~dfsg\d*$//,repacksuffix=~dfsg" \
https://icl.utk.edu/papi/software/index.html .*/papi-(.*)\.tar\.gz
